| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | Static Private Attributes | List of all members
GaudiTool Class Reference

The useful base class for tools. More...

`#include <GaudiTools/GaudiTool.h>`

Inheritance diagram for GaudiTool:
[legend]
Collaboration diagram for GaudiTool:
[legend]

## Public Member Functions
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
INTupleSvc * | ntupleSvc () const
| Access the standard N-Tuple. More...
INTupleSvc * | evtColSvc () const
| Access the standard event collection service. More...
IDataProviderSvc * | detSvc () const
| accessor to detector service More...
IIncidentSvc * | incSvc () const
| accessor to Incident Service More...
IChronoStatSvc * | chronoSvc () const
| accessor to Chrono & Stat Service More...
IHistogramSvc * | histoSvc () const
| acessor to the histogram service More...
IAlgContextSvc * | contextSvc () const
| acessor to the Algorithm Context Service More...
void | put (IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
void | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &address, const bool useRootInTES=true) const
const DataObject * | put (DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
const DataObject * | put (std::unique_ptr< DataObject > object, const std::string &address, const bool useRootInTES=true) const
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data from Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
TYPE * | getDet (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
TYPE * | getDet (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | exist (const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | existDet (IDataProviderSvc *svc, const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE >
bool | existDet (const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
| GaudiTool (const std::string &type, const std::string &name, const IInterface *parent)
| Standard constructor. More...
| ~GaudiTool () override
| destructor, virtual and protected More...
Public Member Functions inherited from GaudiCommon< CounterHolder< AlgTool > >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Quicker version of the get function which bypasses the check on the retrieved data. More...
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
DataObject * | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &location, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
TOOL * | tool (const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
| Useful method for the easy location of tools. More...
TOOL * | tool (const std::string &type, const IInterface *parent=0, bool create=true) const
| A useful method for the easy location of tools. More...
SmartIF< SERVICE > | svc (const std::string &name, const bool create=true) const
| A useful method for the easy location of services. More...
IUpdateManagerSvc * | updMgrSvc () const
| Short-cut to locate the Update Manager Service. More...
WARN_UNUSED StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const
| Print the message and return with the given StatusCode. More...
void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Assert (const bool ok, const char *message, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given GaudiException. More...
void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given exception. More...
void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and throw an exception with the given message. More...
StatEntity & | counter (const std::string &tag) const
| accessor to certain counter by name More...
StatEntity & | counter (const std::string &tag)
bool | typePrint () const
| Insert the actual C++ type of the algorithm/tool in the messages ? More...
bool | propsPrint () const
| Print properties at initialization ? More...
bool | statPrint () const
| Print statistical counters at finalization ? More...
bool | errorsPrint () const
| Print error counters at finalization ? More...
long | printStat (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of statistical counters More...
long | printErrors (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of error counters More...
long | printProps (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of properties More...
void | registerCondition (const std::string &condition, StatusCode(CallerClass::*mf)()=nullptr)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (const std::string &condition, CondType *&condPtrDest, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (char *condition, StatusCode(CallerClass::*mf)()=NULL)
| just to avoid conflicts with the version using a pointer to a template class. More...
void | registerCondition (TargetClass *condition, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
StatusCode | runUpdate ()
| asks the UpdateManagerSvc to perform an update of the instance (if needed) without waiting the next BeginEvent incident. More...
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if PBASE derives from Algorithm. More...
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if PBASE derives from AlgTool. More...
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | release (const IInterface *interface) const
| Manual forced (and 'safe') release of the active tool or service. More...
const Services & | services () const
| get the list of aquired services More...
const std::string & | context () const
| Returns the "context" string. Used to identify different processing states. More...
Public Member Functions inherited from FixTESPath< BASE >
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, BASE>, U>>
| FixTESPath (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if BASE derives from Algorithm. More...
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<AlgTool, BASE>, U>>
| FixTESPath (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if BASE derives from AlgTool. More...
StatusCode | initialize () override
const std::string & | rootInTES () const
| Returns the "rootInTES" string. More...
std::string | fullTESLocation (std::string_view location, bool useRootInTES) const
| Returns the full correct event location given the rootInTes settings. More...

## Static Public Member Functions
static bool | enableSummary (bool)
| enable/disable summary More...
static bool | summaryEnabled ()
| is summary enabled? More...

## Private Member Functions
| GaudiTool ()=delete
| no default/copy constructor, no assignment More...
| GaudiTool (const GaudiTool &)=delete
GaudiTool & | operator= (const GaudiTool &)=delete
bool | isPublic () const
| Determines if this tool is public or not (i.e. owned by the ToolSvc). More...
std::string | getCurrentAlgName () const
| Returns the current active algorithm name via the context service. More...

## Private Attributes
SmartIF< INTupleSvc > | m_ntupleSvc
| pointer to the N-Tuple service More...
SmartIF< INTupleSvc > | m_evtColSvc
| pointer to the event tag collection service More...
SmartIF< IDataProviderSvc > | m_detSvc
| pointer to Detector Data Service More...
SmartIF< IChronoStatSvc > | m_chronoSvc
| pointer to Chrono & Stat Service More...
SmartIF< IIncidentSvc > | m_incSvc
| pointer to Incident Service More...
SmartIF< IHistogramSvc > | m_histoSvc
| pointer for histogram service More...
SmartIF< IAlgContextSvc > | m_contextSvc
| Algorithm Context Service. More...
Gaudi::Property< std::string > | m_contextSvcName
bool | m_isPublic = false
| Flag to say if the tool is a public or private tool. More...
const std::string | m_local
| full tool name "type/name" More...

## Static Private Attributes
static bool | s_enableSummary = true
| enable printout of summary? More...

## Additional Inherited Members
Protected Types inherited from GaudiCommon< CounterHolder< AlgTool > >
using | base_class = FixTESPath< CounterHolder< AlgTool > >
typedef std::map< std::string, StatEntity > | StatisticsOwn
| the actual type of general counters More...
typedef std::map< std::string, std::reference_wrapper< Gaudi::Accumulators::PrintableCounter > > | Statistics
typedef std::map< std::string, unsigned int > | Counter
| the actual type error/warning counter More...
typedef std::vector< IAlgTool * > | AlgTools
| storage for active tools More...
typedef std::vector< SmartIF< IService > > | Services
| storage for active services More...
Protected Member Functions inherited from GaudiCommon< CounterHolder< AlgTool > >
StatusCode | releaseTool (const IAlgTool *tool) const
| manual forced (and 'safe') release of the tool More...
StatusCode | releaseSvc (const IInterface *svc) const
| manual forced (and 'safe') release of the service More...
Protected Attributes inherited from GaudiCommon< CounterHolder< AlgTool > >
SmartIF< ICounterSummarySvc > | m_counterSummarySvc
| a pointer to the CounterSummarySvc More...
Static Protected Attributes inherited from GaudiCommon< CounterHolder< AlgTool > >
static const bool | IgnoreRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...
static const bool | UseRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...

## Detailed Description

The useful base class for tools.

Small extension of ordinary the AlgTool base class.

This base class allows "easy"(=="1 line") access to tools and services. This access is safe in the sense that there is no need to worry about the reference counts for tools and services.

The base class allows "easy" (=="1 line") access to data in Gaudi Transient Stores. The functionality includes the checking of the presence of the data at the given location, checking the validity of the data, retrieval of valid data and "forced" retrieve of valid data (create if there is no data).

The base class allows to perform an easy error, warning and exception treatments, including the accumulated statistics of exceptions, errors and warnings.

The base class also includes utilities for general statistical counters.

It has been reported that usage of this base class results in significant reduction of existing code lines.

Attention
  See the class GaudiCommon, which implements some of the common functionality between GaudiTool and GaudiAlgorithm

Author
  Vanya BELYAEV Ivan..nosp@m.Bely.nosp@m.aev@i.nosp@m.tep..nosp@m.ru
  Chris Jones Chris.nosp@m.toph.nosp@m.er.Ro.nosp@m.b.Jo.nosp@m.nes@c.nosp@m.ern..nosp@m.ch

Date
  2003-07-07

Definition at line 101 of file GaudiTool.h.

## Constructor & Destructor Documentation

## ◆ GaudiTool() [1/3]

GaudiTool::GaudiTool | ( | const std::string & | type,
|  | const std::string & | name,
|  | const IInterface * | parent
| ) |  |

Standard constructor.

See also
  AlgTool

Parameters

  type | tool type (useless)
  name | tool name
  parent | pointer to parent object (service, algorithm or tool)

Definition at line 132 of file GaudiTool.cpp.

133 : GaudiCommon<CounterHolder<AlgTool>>( this_type, this_name, parent ), m_local( this_type + "/" + this_name ) {
134 // make instance counts
135 GaudiToolLocal::s_InstanceCounter.increment( m_local );
136 }
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:776

## ◆ ~GaudiTool()

GaudiTool::~GaudiTool | ( |  | ) |
| override

destructor, virtual and protected

Definition at line 140 of file GaudiTool.cpp.

140 { GaudiToolLocal::s_InstanceCounter.decrement( m_local ); }
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:776

## ◆ GaudiTool() [2/3]

GaudiTool::GaudiTool | ( |  | ) |
| private delete

no default/copy constructor, no assignment

## ◆ GaudiTool() [3/3]

GaudiTool::GaudiTool | ( | const GaudiTool & |  | ) |
| private delete

## Member Function Documentation

## ◆ chronoSvc()

IChronoStatSvc * GaudiTool::chronoSvc | ( |  | ) | const

accessor to Chrono & Stat Service

Returns
  pointer to the Chrono & Stat Service

Definition at line 227 of file GaudiTool.cpp.

227 {
228 if ( UNLIKELY( !m_chronoSvc ) ) m_chronoSvc = service( GaudiToolServices::s_ChronoStatSvc, true );
229 return m_chronoSvc;
230 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiToolServices::s_ChronoStatSvc
const std::string s_ChronoStatSvc
the default name for Chrono & Stat Service
Definition: GaudiTool.cpp:46
GaudiTool::m_chronoSvc
SmartIF< IChronoStatSvc > m_chronoSvc
pointer to Chrono & Stat Service
Definition: GaudiTool.h:757

## ◆ contextSvc()

IAlgContextSvc * GaudiTool::contextSvc | ( |  | ) | const

acessor to the Algorithm Context Service

Returns
  pointer to the Algorithm Context Service

Definition at line 241 of file GaudiTool.cpp.

241 {
242 if ( UNLIKELY( !m_contextSvc ) ) m_contextSvc = service( m_contextSvcName, true );
243 return m_contextSvc;
244 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiTool::m_contextSvc
SmartIF< IAlgContextSvc > m_contextSvc
Algorithm Context Service.
Definition: GaudiTool.h:763
GaudiTool::m_contextSvcName
Gaudi::Property< std::string > m_contextSvcName
Definition: GaudiTool.h:765

## ◆ detSvc()

IDataProviderSvc * GaudiTool::detSvc | ( |  | ) | const

accessor to detector service

Returns
  pointer to detector service

Definition at line 199 of file GaudiTool.cpp.

199 {
200 if ( UNLIKELY( !m_detSvc ) ) m_detSvc = service( GaudiToolServices::s_DetectorDataSvc, true );
201 return m_detSvc;
202 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiToolServices::s_DetectorDataSvc
const std::string s_DetectorDataSvc
the default name for Detector Data Service
Definition: GaudiTool.cpp:44
GaudiTool::m_detSvc
SmartIF< IDataProviderSvc > m_detSvc
pointer to Detector Data Service
Definition: GaudiTool.h:755

## ◆ enableSummary()

bool GaudiTool::enableSummary | ( | bool | value | ) |
| static

enable/disable summary

Definition at line 117 of file GaudiTool.cpp.

118 {
119 s_enableSummary = value;
120 return summaryEnabled();
121 }
GaudiTool::s_enableSummary
static bool s_enableSummary
enable printout of summary?
Definition: GaudiTool.h:781
GaudiTool::summaryEnabled
static bool summaryEnabled()
is summary enabled?
Definition: GaudiTool.cpp:125

## ◆ Error()

StatusCode GaudiTool::Error | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::FAILURE`,
|  | const size_t | mx = `10`
| ) |  | const
| inline

Print the error message and return with the given StatusCode.

Also performs statistical analysis of the error messages and suppression after the defined number of error instances.

if( a < 0 ) { return Error("a is negative!") ;}
if( b < 0 ) { return Error("b is illegal!" , StatusCode(25) );
if( c < 0 )
{ return Error("c is negative" , StatusCode(35) , 50 );

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | Error message
  st | StatusCode to return
  mx | Maximum number of printouts for this message

Returns
  StatusCode

Definition at line 663 of file GaudiTool.h.

663 {
664 return GaudiCommon<CounterHolder<AlgTool>>::Error( m_isPublic ? msg + getCurrentAlgName() : msg, st, mx );
665 }
GaudiTool::Error
StatusCode Error(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the error message and return with the given StatusCode.
Definition: GaudiTool.h:663
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:771
GaudiMP.FdsRegistry.msg
msg
Definition: FdsRegistry.py:8
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
GaudiTool::getCurrentAlgName
std::string getCurrentAlgName() const
Returns the current active algorithm name via the context service.
Definition: GaudiTool.h:742

## ◆ evtColSvc()

INTupleSvc * GaudiTool::evtColSvc | ( |  | ) | const

Access the standard event collection service.

Returns
  pointer to the event collection service

Definition at line 213 of file GaudiTool.cpp.

213 {
214 if ( UNLIKELY( !m_evtColSvc ) ) m_evtColSvc = service( "EvtTupleSvc", true );
215 return m_evtColSvc;
216 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiTool::m_evtColSvc
SmartIF< INTupleSvc > m_evtColSvc
pointer to the event tag collection service
Definition: GaudiTool.h:753

## ◆ exist() [1/2]

template<class TYPE >

bool GaudiTool::exist | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Check the existence of a data object or container in the Gaudi Transient Event Store.

bool a1 = exist<DataObject>( evtSvc(), "/Event/MyObject" ) ;
bool a2 = exist<MyHits> ( evtSvc(), "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  svc | Pointer to data service (data provider)
  location | Address in Gaudi Transient Event Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  Boolean indicating status of the request

Return values

  true | Data object or container exists and implements a proper interface
  true | Failed to locate the data object or container

Definition at line 503 of file GaudiTool.h.

503 {
504 return GaudiCommon<CounterHolder<AlgTool>>::exist<TYPE>( svc, location, useRootInTES );
505 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ exist() [2/2]

template<class TYPE >

bool GaudiTool::exist | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Check the existence of a data object or container in the Gaudi Transient Event Store.

bool a1 = exist<DataObject>( "/Event/MyObject" ) ;
bool a2 = exist<MyHits> ( "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  location | Address in Gaudi Transient Event Store

Returns
  Boolean indicating status of the request

Return values

  true | Data object or container exists and implements a proper interface
  true | Failed to locate the data object or container

Definition at line 530 of file GaudiTool.h.

530 {
531 return GaudiCommon<CounterHolder<AlgTool>>::exist<TYPE>( evtSvc(), location, useRootInTES );
532 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ existDet() [1/2]

template<class TYPE >

bool GaudiTool::existDet | ( | IDataProviderSvc * | svc,
|  | const std::string & | location
| ) |  | const
| inline

Check the existence of detector objects in the Gaudi Transient Detector Store.

bool a1 = existDet<DataObject> ( detSvc(), "/dd/Structure/MyObject" ) ;
bool a2 = existDet<Material> ( detSvc(), "/dd/Structure/Material/Air" ) ;

Parameters

  svc | Pointer to data service (data provider)
  location | Address in Gaudi Transient Detector Store

Returns
  Boolean indicating status of the request

Return values

  true | Detector object exists and implements a proper interface
  false | Failed to locate the data object

Definition at line 551 of file GaudiTool.h.

551 {
552 return GaudiCommon<CounterHolder<AlgTool>>::exist<TYPE>( svc, location, false );
553 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ existDet() [2/2]

template<class TYPE >

bool GaudiTool::existDet | ( | const std::string & | location | ) | const
| inline

Check the existence of detector objects in the Gaudi Transient Detector Store.

bool a1 = existDet<DataObject> ( "/dd/Structure/MyObject" ) ;
bool a2 = existDet<Material> ( "/dd/Structure/Material/Air" ) ;

Parameters

  location | Address in Gaudi Transient Detector Store

Returns
  Boolean indicating status of the request

Return values

  true | Detector object exists and implements a proper interface
  false | Failed to locate the data object

Definition at line 571 of file GaudiTool.h.

571 {
572 return GaudiCommon<CounterHolder<AlgTool>>::exist<TYPE>( detSvc(), location, false );
573 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiTool::detSvc
IDataProviderSvc * detSvc() const
accessor to detector service
Definition: GaudiTool.cpp:199
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ finalize()

StatusCode GaudiTool::finalize | ( |  | ) |
| override

standard finalization method

See also
  AlgTool
  IAlgTool

Returns
  status code

Definition at line 161 of file GaudiTool.cpp.

161 {
162 if ( msgLevel( MSG::DEBUG ) ) debug() << " ==> Finalize the base class GaudiTool " << endmsg;
163
164 // clear "explicit services"
165 m_detSvc.reset();
166 m_chronoSvc.reset();
167 m_incSvc.reset();
168 m_histoSvc.reset();
169
170 // finalize the base class
171 const StatusCode sc = GaudiCommon<CounterHolder<AlgTool>>::finalize();
172 if ( sc.isFailure() ) { return sc; }
173
174 // Decrement the counter
175 GaudiToolLocal::s_FinalizeCounter.decrement( m_local );
176
177 // return
178 return sc;
179 }
MSG::DEBUG
Definition: IMessageSvc.h:15
GaudiTool::m_incSvc
SmartIF< IIncidentSvc > m_incSvc
pointer to Incident Service
Definition: GaudiTool.h:759
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
GaudiTool::m_chronoSvc
SmartIF< IChronoStatSvc > m_chronoSvc
pointer to Chrono & Stat Service
Definition: GaudiTool.h:757
GaudiTool::m_histoSvc
SmartIF< IHistogramSvc > m_histoSvc
pointer for histogram service
Definition: GaudiTool.h:761
GaudiTool::finalize
StatusCode finalize() override
standard finalization method
Definition: GaudiTool.cpp:161
GaudiTool::m_detSvc
SmartIF< IDataProviderSvc > m_detSvc
pointer to Detector Data Service
Definition: GaudiTool.h:755
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:86
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:776
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ get() [1/2]

template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::get | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data in Gaudi Transient Store.

Quick and safe access to the data in Gaudi transient store. The method located the data at given address and perform the debug printout about located data

MCHits* hits = get<MCHits>( evtSvc() , "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc
  SmartDataPtr

Exceptions

  GaudiException | for Invalid Data Provider Service
  GaudiException | for invalid/unavailable data

Parameters

  svc | Pointer to data service (data provider)
  location | data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  pointer to the data object

Definition at line 265 of file GaudiTool.h.

266 {
267 return GaudiCommon<CounterHolder<AlgTool>>::get<TYPE>( svc, location, useRootInTES );
268 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ get() [2/2]

template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::get | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data from Gaudi Event Transient Store.

Quick and safe access to the data in Gaudi transient store.

The method located the data at the given address and perform the debug printout about located data.

MCParticles* mcps = get<MCParticles>( MCParticleLocation::Default );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  location | Data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  Pointer to the data object

Definition at line 335 of file GaudiTool.h.

336 {
337 return GaudiCommon<CounterHolder<AlgTool>>::get<TYPE>( evtSvc(), location, useRootInTES );
338 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getCurrentAlgName()

std::string GaudiTool::getCurrentAlgName | ( |  | ) | const
| inline private

Returns the current active algorithm name via the context service.

Definition at line 742 of file GaudiTool.h.

742 {
743 const IAlgContextSvc* asvc = this->contextSvc();
744 const IAlgorithm* current = ( asvc ? asvc->currentAlg() : NULL );
745 return ( current ? " [" + current->name() + "]" : "" );
746 }
IAlgorithm
The IAlgorithm is the interface implemented by the Algorithm base class.
Definition: IAlgorithm.h:28
GaudiTool::contextSvc
IAlgContextSvc * contextSvc() const
acessor to the Algorithm Context Service
Definition: GaudiTool.cpp:241
IAlgContextSvc
An abstract interface for Algorithm Context Service.
Definition: IAlgContextSvc.h:23
IAlgContextSvc::currentAlg
virtual IAlgorithm * currentAlg() const =0
accessor to current algorithm:

## ◆ getDet() [1/2]

template<class TYPE >

TYPE* GaudiTool::getDet | ( | IDataProviderSvc * | svc,
|  | const std::string & | location
| ) |  | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

MyDet* mdet = getDet<MyDet>( detSvc() , "/dd/Structure/LHCb/MyDet" );

Parameters

  svc | Pointer to data service (data provider)
  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Definition at line 397 of file GaudiTool.h.

397 {
398 return GaudiCommon<CounterHolder<AlgTool>>::get<TYPE>( svc, location, false );
399 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getDet() [2/2]

template<class TYPE >

TYPE* GaudiTool::getDet | ( | const std::string & | location | ) | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

MyDet* mdet = getDet<MyDet>( "/dd/Structure/LHCb/MyDet" );

Parameters

  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Definition at line 447 of file GaudiTool.h.

447 {
448 return GaudiCommon<CounterHolder<AlgTool>>::get<TYPE>( detSvc(), location, false );
449 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiTool::detSvc
IDataProviderSvc * detSvc() const
accessor to detector service
Definition: GaudiTool.cpp:199
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getDetIfExists() [1/2]

template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getDetIfExists | ( | IDataProviderSvc * | svc,
|  | const std::string & | location
| ) |  | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MyDet* mdet = getDetIfExists<MyDet>( detSvc() , "/dd/Structure/LHCb/MyDet" );

Parameters

  svc | Pointer to data service (data provider)
  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Return values

  NULL | If the detector object does not exist.

Definition at line 424 of file GaudiTool.h.

425 {
426 return GaudiCommon<CounterHolder<AlgTool>>::getIfExists<TYPE>( svc, location, false );
427 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getDetIfExists() [2/2]

template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getDetIfExists | ( | const std::string & | location | ) | const
| inline

Templated access to the detector data from the Gaudi Detector Transient Store.

Quick and safe access to the detector data in Gaudi transient store.

The method located the detector at the given address and perform the debug printout about located detector.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MyDet* mdet = getDetIfExists<MyDet>( "/dd/Structure/LHCb/MyDet" );

Parameters

  location | Detector location/address in Gaudi Transient Store

Returns
  Pointer to the detector object

Return values

  NULL | If the detector object does not exist.

Definition at line 473 of file GaudiTool.h.

473 {
474 return GaudiCommon<CounterHolder<AlgTool>>::getIfExists<TYPE>( detSvc(), location, false );
475 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiTool::detSvc
IDataProviderSvc * detSvc() const
accessor to detector service
Definition: GaudiTool.cpp:199
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getIfExists() [1/2]

template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getIfExists | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data in Gaudi Transient Store.

Quick and safe access to the data in Gaudi transient store. The method located the data at given address and perform the debug printout about located data.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MCHits* hits = getIfExists<MCHits>( evtSvc() , "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc
  SmartDataPtr

Parameters

  svc | Pointer to data service (data provider)
  location | data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  pointer to the data object.

Return values

  NULL | If data does not exist.

Definition at line 304 of file GaudiTool.h.

305 {
306 return GaudiCommon<CounterHolder<AlgTool>>::getIfExists<TYPE>( svc, location, useRootInTES );
307 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getIfExists() [2/2]

template<class TYPE >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getIfExists | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Templated access to the data in Gaudi Transient Store.

Quick and safe access to the data in Gaudi transient store. The method located the data at given address and perform the debug printout about located data.

Skips the check on the data as performed by 'get'. No exception is thrown if the data is missing.

MCHits* hits = getIfExists<MCHits>( "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc
  SmartDataPtr

Parameters

  location | data location/address in Gaudi Transient Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  pointer to the data object.

Return values

  NULL | If data does not exist.

Definition at line 373 of file GaudiTool.h.

374 {
375 return GaudiCommon<CounterHolder<AlgTool>>::getIfExists<TYPE>( evtSvc(), location, useRootInTES );
376 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getOrCreate() [1/2]

template<class TYPE , class TYPE2 >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getOrCreate | ( | IDataProviderSvc * | svc,
|  | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Get the existing data object from Gaudi Event Transient store.

Alternatively, create new object and register it in TES and return if object does not exist.

MyHits* hits = getOrCreate<MyHits,MyHits>( evtSvc() , "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Exceptions

  GaudiException | for Invalid Data Provider Service
  GaudiException | for invalid/unavailable data

Parameters

  svc | Pointer to data service (data provider)
  location | Location in Gaudi Transient Event Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  A valid pointer to the object

Definition at line 602 of file GaudiTool.h.

603 {
604 return GaudiCommon<CounterHolder<AlgTool>>::getOrCreate<TYPE, TYPE2>( svc, location, useRootInTES );
605 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ getOrCreate() [2/2]

template<class TYPE , class TYPE2 >

Gaudi::Utils::GetData<TYPE>::return_type GaudiTool::getOrCreate | ( | const std::string & | location,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Get the existing data object from Gaudi Event Transient store.

Alternatively, create new object and register it in TES and return if object does not exist.

MyHits* hits = getOrCreate<MyHits,MyHits>( "/Event/MyHits" ) ;

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Exceptions

  GaudiException | for Invalid Data Provider Service
  GaudiException | for invalid/unavailable data

Parameters

  location | Location in Gaudi Transient Event Store
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Returns
  A valid pointer to the object

Definition at line 633 of file GaudiTool.h.

634 {
635 return GaudiCommon<CounterHolder<AlgTool>>::getOrCreate<TYPE, TYPE2>( evtSvc(), location, useRootInTES );
636 }
GaudiPython.HistoUtils.location
location
Definition: HistoUtils.py:936
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ histoSvc()

IHistogramSvc * GaudiTool::histoSvc | ( |  | ) | const

acessor to the histogram service

Returns
  pointer to the histogram service

Definition at line 234 of file GaudiTool.cpp.

234 {
235 if ( UNLIKELY( !m_histoSvc ) ) m_histoSvc = service( GaudiToolServices::s_HistoSvc, true );
236 return m_histoSvc;
237 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiToolServices::s_HistoSvc
const std::string s_HistoSvc
the default name for Histogram Service
Definition: GaudiTool.cpp:50
GaudiTool::m_histoSvc
SmartIF< IHistogramSvc > m_histoSvc
pointer for histogram service
Definition: GaudiTool.h:761

## ◆ incSvc()

IIncidentSvc * GaudiTool::incSvc | ( |  | ) | const

accessor to Incident Service

Returns
  pointer to the Incident Service

Definition at line 220 of file GaudiTool.cpp.

220 {
221 if ( UNLIKELY( !m_incSvc ) ) m_incSvc = service( GaudiToolServices::s_IncidentSvc, true );
222 return m_incSvc;
223 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiTool::m_incSvc
SmartIF< IIncidentSvc > m_incSvc
pointer to Incident Service
Definition: GaudiTool.h:759
GaudiToolServices::s_IncidentSvc
const std::string s_IncidentSvc
the default name for Incident Service
Definition: GaudiTool.cpp:48

## ◆ Info()

StatusCode GaudiTool::Info | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::SUCCESS`,
|  | const size_t | mx = `10`
| ) |  | const
| inline

Print the info message and return with the given StatusCode.

Also performs statistical analysis of the info messages and suppression after the defined number of instances.

See also
  MsgStream
  IMessageSvc
  StatusCode
  GaudiCommon::Warning

Parameters

  msg | Info message
  st | StatusCode to return
  mx | Maximum number of printouts for this message

Returns
  The given StatusCode

Definition at line 707 of file GaudiTool.h.

707 {
708 return GaudiCommon<CounterHolder<AlgTool>>::Info( m_isPublic ? msg + getCurrentAlgName() : msg, st, mx );
709 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:771
GaudiTool::Info
StatusCode Info(const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
Print the info message and return with the given StatusCode.
Definition: GaudiTool.h:707
GaudiMP.FdsRegistry.msg
msg
Definition: FdsRegistry.py:8
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
GaudiTool::getCurrentAlgName
std::string getCurrentAlgName() const
Returns the current active algorithm name via the context service.
Definition: GaudiTool.h:742

## ◆ initialize()

StatusCode GaudiTool::initialize | ( |  | ) |
| override

standard initialization method

See also
  AlgTool
  IAlgTool

Returns
  status code

Definition at line 144 of file GaudiTool.cpp.

144 {
145 // initialize the base class
146 const StatusCode sc = GaudiCommon<CounterHolder<AlgTool>>::initialize();
147 if ( sc.isFailure() ) { return sc; }
148
149 // increment the counter
150 GaudiToolLocal::s_FinalizeCounter.increment( m_local );
151
152 // are we a public tool ?
153 m_isPublic = isPublic();
154
155 // return
156 return sc;
157 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:771
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
GaudiTool::m_local
const std::string m_local
full tool name "type/name"
Definition: GaudiTool.h:776
GaudiTool::initialize
StatusCode initialize() override
standard initialization method
Definition: GaudiTool.cpp:144
GaudiTool::isPublic
bool isPublic() const
Determines if this tool is public or not (i.e. owned by the ToolSvc).
Definition: GaudiTool.cpp:183

## ◆ isPublic()

bool GaudiTool::isPublic | ( |  | ) | const
| private

Determines if this tool is public or not (i.e. owned by the ToolSvc).

Definition at line 183 of file GaudiTool.cpp.

183 {
184 const IAlgTool* tool = this;
185 // Recurse down the ownership tree, to see with we ever end up at the ToolSvc
186 bool ownedByToolSvc = false;
187 unsigned int sanityCheck( 0 );
188 while ( tool && ++sanityCheck < 99999 ) {
189 ownedByToolSvc = ( nullptr != dynamic_cast<const IToolSvc*>( tool->parent() ) );
190 if ( ownedByToolSvc ) { break; }
191 // if parent is also a tool, try again
192 tool = dynamic_cast<const IAlgTool*>( tool->parent() );
193 }
194 return ownedByToolSvc;
195 }
GaudiCommon< CounterHolder< AlgTool > >::tool
TOOL * tool(const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
Useful method for the easy location of tools.
Definition: GaudiCommonImp.h:81
IAlgTool
The interface implemented by the AlgTool base class.
Definition: IAlgTool.h:23

## ◆ ntupleSvc()

INTupleSvc * GaudiTool::ntupleSvc | ( |  | ) | const

Access the standard N-Tuple.

Returns
  pointer to N-Tuple service .

Definition at line 206 of file GaudiTool.cpp.

206 {
207 if ( UNLIKELY( !m_ntupleSvc ) ) m_ntupleSvc = service( "NTupleSvc", true );
208 return m_ntupleSvc;
209 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
GaudiTool::m_ntupleSvc
SmartIF< INTupleSvc > m_ntupleSvc
pointer to the N-Tuple service
Definition: GaudiTool.h:751

## ◆ operator=()

GaudiTool& GaudiTool::operator= | ( | const GaudiTool & |  | ) |
| private delete

## ◆ put() [1/4]

void GaudiTool::put | ( | IDataProviderSvc * | svc,
|  | DataObject * | object,
|  | const std::string & | address,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Register a data object or container into Gaudi Event Transient Store.

MCHits * hits = new MCHits();
put( evtSvc(), hits, "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

See also
  IDataProviderSvc

Parameters

  svc | Pointer to data provider service
  object | Data object or container to be registered
  address | Address in Gaudi Event Transient Store ("/Event" could be omitted )
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Exceptions

  GaudiException | for invalid event data service
  GaudiException | for invalid object
  GaudiException | for error result from event data service

Returns
  StatusCode

Return values

  StatusCode::SUCCESS | Data was successfully placed in the TES.
  StatusCode::FAILURE | Failed to store data in the TES.

Definition at line 188 of file GaudiTool.h.

189 {
190 put( svc, std::unique_ptr<DataObject>( object ), address, useRootInTES );
191 }
GaudiTool::put
void put(IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
Register a data object or container into Gaudi Event Transient Store.
Definition: GaudiTool.h:188
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
std::unique_ptr
STL class.

## ◆ put() [2/4]

void GaudiTool::put | ( | IDataProviderSvc * | svc,
|  | std::unique_ptr< DataObject > | object,
|  | const std::string & | address,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Definition at line 192 of file GaudiTool.h.

193 {
194 GaudiCommon<CounterHolder<AlgTool>>::put( svc, std::move( object ), address, useRootInTES );
195 }
GaudiTool::put
void put(IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
Register a data object or container into Gaudi Event Transient Store.
Definition: GaudiTool.h:188
GaudiCommon< CounterHolder< AlgTool > >::svc
SmartIF< SERVICE > svc(const std::string &name, const bool create=true) const
A useful method for the easy location of services.
Definition: GaudiCommonImp.h:121
std::move
T move(T... args)
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ put() [3/4]

const DataObject* GaudiTool::put | ( | DataObject * | object,
|  | const std::string & | address,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Register a data object or container into Gaudi Event Transient Store.

See also
  IDataProviderSvc

MCHits * hits = put( new MCHits(), "/Event/MC/Hits" );

Attention
  The method respects the setting of the job option RootInTES by prepending the value of this to the data location that is passed. The default setting for RootInTES is "" so has no effect. This behavior can be suppressed by passing the argument useRootInTES = false

Parameters

  object | Data object or container to be registered
  address | Address in Gaudi Event Transient Store ("/Event" could be omitted )
  useRootInTES | Flag to turn on(TRUE) off(FALSE) the use of the RootInTES location property

Exceptions

  GaudiException | for invalid event data service
  GaudiException | for invalid object
  GaudiException | for error result from event data service

Returns
  StatusCode

Return values

  StatusCode::SUCCESS | Data was successfully placed in the TES.
  StatusCode::FAILURE | Failed to store data in the TES.

Definition at line 225 of file GaudiTool.h.

225 {
226 return put( std::unique_ptr<DataObject>( object ), address, useRootInTES );
227 }
GaudiTool::put
void put(IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
Register a data object or container into Gaudi Event Transient Store.
Definition: GaudiTool.h:188
std::unique_ptr
STL class.

## ◆ put() [4/4]

const DataObject* GaudiTool::put | ( | std::unique_ptr< DataObject > | object,
|  | const std::string & | address,
|  | const bool | useRootInTES = `true`
| ) |  | const
| inline

Definition at line 228 of file GaudiTool.h.

229 {
230 return GaudiCommon<CounterHolder<AlgTool>>::put( evtSvc(), std::move( object ), address, useRootInTES );
231 }
GaudiTool::put
void put(IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
Register a data object or container into Gaudi Event Transient Store.
Definition: GaudiTool.h:188
std::move
T move(T... args)
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91

## ◆ summaryEnabled()

bool GaudiTool::summaryEnabled | ( |  | ) |
| static

is summary enabled?

Definition at line 125 of file GaudiTool.cpp.

126 {
127 return s_enableSummary;
128 }
GaudiTool::s_enableSummary
static bool s_enableSummary
enable printout of summary?
Definition: GaudiTool.h:781

## ◆ Warning()

StatusCode GaudiTool::Warning | ( | const std::string & | msg,
|  | const StatusCode | st = `StatusCode::FAILURE`,
|  | const size_t | mx = `10`
| ) |  | const
| inline

Print the warning message and return with the given StatusCode.

Also performs statistical analysis of the warning messages and suppression after the defined number of error instances.

if( a < 0 ) { return Warning("a is negative!") ;}
if( b < 0 ) { return Warning("b is illegal!" , StatusCode(25) );
if( c < 0 )
{ return Warning("c is negative" , StatusCode(35) , 50 );

See also
  MsgStream
  IMessageSvc
  StatusCode

Parameters

  msg | Warning message
  st | StatusCode to return
  mx | Maximum number of printouts for this message

Returns
  The given StatusCode

Definition at line 689 of file GaudiTool.h.

689 {
690 return GaudiCommon<CounterHolder<AlgTool>>::Warning( m_isPublic ? msg + getCurrentAlgName() : msg, st, mx );
691 }
GaudiTool::m_isPublic
bool m_isPublic
Flag to say if the tool is a public or private tool.
Definition: GaudiTool.h:771
GaudiTool::Warning
StatusCode Warning(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the warning message and return with the given StatusCode.
Definition: GaudiTool.h:689
GaudiMP.FdsRegistry.msg
msg
Definition: FdsRegistry.py:8
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
GaudiTool::getCurrentAlgName
std::string getCurrentAlgName() const
Returns the current active algorithm name via the context service.
Definition: GaudiTool.h:742

## Member Data Documentation

## ◆ m_chronoSvc

SmartIF<IChronoStatSvc> GaudiTool::m_chronoSvc
| mutable private

pointer to Chrono & Stat Service

Definition at line 757 of file GaudiTool.h.

## ◆ m_contextSvc

SmartIF<IAlgContextSvc> GaudiTool::m_contextSvc
| mutable private

Algorithm Context Service.

Definition at line 763 of file GaudiTool.h.

## ◆ m_contextSvcName

Gaudi::Property<std::string> GaudiTool::m_contextSvcName
| private

Initial value:
{this, "ContextService", "AlgContextSvc",
"the name of Algorithm Context Service"}

Definition at line 765 of file GaudiTool.h.

## ◆ m_detSvc

SmartIF<IDataProviderSvc> GaudiTool::m_detSvc
| mutable private

pointer to Detector Data Service

Definition at line 755 of file GaudiTool.h.

## ◆ m_evtColSvc

SmartIF<INTupleSvc> GaudiTool::m_evtColSvc
| mutable private

pointer to the event tag collection service

Definition at line 753 of file GaudiTool.h.

## ◆ m_histoSvc

SmartIF<IHistogramSvc> GaudiTool::m_histoSvc
| mutable private

pointer for histogram service

Definition at line 761 of file GaudiTool.h.

## ◆ m_incSvc

SmartIF<IIncidentSvc> GaudiTool::m_incSvc
| mutable private

pointer to Incident Service

Definition at line 759 of file GaudiTool.h.

## ◆ m_isPublic

bool GaudiTool::m_isPublic = false
| private

Flag to say if the tool is a public or private tool.

Definition at line 771 of file GaudiTool.h.

## ◆ m_local

const std::string GaudiTool::m_local
| private

full tool name "type/name"

Definition at line 776 of file GaudiTool.h.

## ◆ m_ntupleSvc

SmartIF<INTupleSvc> GaudiTool::m_ntupleSvc
| mutable private

pointer to the N-Tuple service

Definition at line 751 of file GaudiTool.h.

## ◆ s_enableSummary

bool GaudiTool::s_enableSummary = true
| static private

enable printout of summary?

summary is enabled

Definition at line 781 of file GaudiTool.h.

The documentation for this class was generated from the following files:

- GaudiAlg/GaudiAlg/GaudiTool.h
- GaudiAlg/src/lib/GaudiTool.cpp